unit EncIntercept;

interface

uses
  IdBaseComponent, IdIntercept, Classes;

type
  TEncIntercept = class(TIdConnectionIntercept)
  public
    procedure Send(ABuffer: TStream); override;
  end;

implementation

{ TEncIntercept }

procedure TEncIntercept.Send(ABuffer: TStream);
var
  i: Integer;
  LMsg: array [0..100] of char;
begin
  ABuffer.ReadBuffer(LMsg, ABuffer.Size);
  i := 0;
  while LMsg[i] <> #13 do begin
    LMsg[i] := Chr(Ord(LMsg[i]) + 1);
    inc(i);
  end;
  ABuffer.Size := 0;
  // Special case: We are sending Lines seperated by #13#10, so that's
  // why in this case we need to only check until CRLF and then add 2
  // more bytes to include those chars. Other end is expecting CRLF
  ABuffer.WriteBuffer(LMsg, i + 2);
  // Call inherited to send buffer info
  inherited;
end;

end.
